include masm32rt.inc
include c:\masm32\macros\macros.asm

 .data
 teststring db "teststring",0
 searchstring  db "STEER",0
 .data?
 p2File dd ?
 .code
; 
; LoadFile loads a disk file into a memory buffer of the same length,
; lpName is the disk file to open
; hMem$ is the memory block that the file was copied to
; Return values: eax is pointer to memory
;				 ecx file size in bytes
; 

LoadFile proc lpName:DWORD

    LOCAL hFile     :DWORD		;handle to file
    LOCAL flen        :DWORD	;file lenght
    LOCAL bRead     :DWORD
    LOCAL hMem     :DWORD      ; source memory handle
    
    invoke CreateFile,lpName,GENERIC_READ,0,NULL,OPEN_EXISTING,NULL,NULL
    mov hFile, eax

    invoke GetFileSize,hFile,NULL
    mov flen, eax

    stralloc flen		;allocate flen bytes of space on the heap for tthe file
    mov hMem, eax      ; pointer to allocated memory

    invoke ReadFile,hFile,hMem,flen,ADDR bRead,NULL
    invoke CloseHandle,hFile
	mov eax,hMem
	mov ecx,flen
    ;strfree hMem			the calling proc has to free allocated memory when done

    ret

LoadFile endp
; 

string Proc
  LOCAL buffer[80]:BYTE
  LOCAL  lpbuf :dword
  LOCAL sPos :dword	
    ;mov lpbuf, ptr$(buffer)   ; cast buffer to pointer
    
    ;print offset searchstring
    xor eax,eax
    xor ecx,ecx
    L1:
    lea edx,sPos
   invoke readline, p2File, addr buffer,dword ptr [edx]
    cmp eax,0
    je getout
    mov sPos,eax
	cmp ecx,0
    je emptyline
    invoke InString,2,ADDR buffer,offset searchstring
	.if eax > 1
     print addr buffer,13,10	;put line where desired
     .else
     .endif
     emptyline:
     mov  buffer,0
     jmp L1
  	getout:
    
ret
string endp

start:


fn LoadFile,"LaborCode.txt"
cmp eax,0
jne fileLoaded
fn MessageBox,0,"the file could not be opened", "ERROR loading file!",MB_OK
fileLoaded:
mov p2File, eax
;invoke StdIn,offset searchstring,16

;print offset searchstring
call string
strfree p2File			;the calling proc has to free allocated memory when done
inkey
push 0
call ExitProcess
END start